package com.yunzhupaas.mdm.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import com.yunzhupaas.base.ActionResult;
import com.yunzhupaas.base.UserInfo;
import com.yunzhupaas.exception.DataException;
import com.yunzhupaas.permission.entity.UserEntity;
import com.yunzhupaas.constant.MsgCode;
import com.yunzhupaas.mdm.service.*;
import com.yunzhupaas.mdm.entity.*;
import com.yunzhupaas.util.*;
import com.yunzhupaas.mdm.model.material.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.yunzhupaas.flowable.entity.TaskEntity;
import jakarta.validation.Valid;
import java.util.*;
import com.yunzhupaas.model.ExcelModel;
import com.yunzhupaas.excel.ExcelExportStyler;
import com.yunzhupaas.excel.ExcelHelper;
import com.yunzhupaas.annotation.YunzhupaasField;
import com.yunzhupaas.base.vo.PageListVO;
import com.yunzhupaas.base.vo.PaginationVO;
import com.yunzhupaas.base.vo.DownloadVO;
import com.yunzhupaas.config.ConfigValueUtil;
import com.yunzhupaas.base.entity.ProvinceEntity;
import java.io.IOException;
import java.util.stream.Collectors;
import com.yunzhupaas.flowable.entity.TaskEntity;
import com.yunzhupaas.exception.WorkFlowException;
import com.yunzhupaas.model.visualJson.UploaderTemplateModel;
import com.yunzhupaas.base.util.FormExecelUtils;
import org.springframework.web.multipart.MultipartFile;
import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.ExcelImportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;
import cn.afterturn.easypoi.excel.entity.ImportParams;
import cn.afterturn.easypoi.excel.entity.params.ExcelExportEntity;
import cn.afterturn.easypoi.excel.entity.enmus.ExcelType;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import com.yunzhupaas.onlinedev.model.ExcelImFieldModel;
import com.yunzhupaas.base.model.OnlineImport.ImportDataModel;
import com.yunzhupaas.base.model.OnlineImport.ImportFormCheckUniqueModel;
import com.yunzhupaas.base.model.OnlineImport.ExcelImportModel;
import com.yunzhupaas.base.model.OnlineImport.VisualImportModel;
import cn.xuyanwu.spring.file.storage.FileInfo;
import lombok.Cleanup;
import com.yunzhupaas.model.visualJson.config.HeaderModel;
import com.yunzhupaas.base.model.ColumnDataModel;
import com.yunzhupaas.base.util.VisualUtils;
import org.springframework.transaction.annotation.Transactional;

/**
 * 物料信息
 * @版本： V5.2.7
 * @版权： Copyright @ 2025  深圳市乐程软件有限公司版权所有
 * @作者： 深圳市乐程软件有限公司
 * @日期： 2026-04-27
 */
@Slf4j
@RestController
@Tag(name = "物料信息" , description = "bcm")
@RequestMapping("/api/bcm/Material")
public class MaterialController {

    @Autowired
    private GeneraterSwapUtil generaterSwapUtil;

    @Autowired
    private UserProvider userProvider;

    @Autowired
    private MaterialService materialService;



    @Autowired
    private ConfigValueUtil configValueUtil;

    /**
    * 列表
    *
    * @param materialPagination
    * @return
    */
    @Operation(summary = "获取列表")
    @PostMapping("/getList")
    public ActionResult list(@RequestBody MaterialPagination materialPagination)throws Exception{
        List<MaterialEntity> list= materialService.getList(materialPagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (MaterialEntity entity : list) {
        Map<String, Object> materialMap=JsonUtil.entityToMap(entity);
        materialMap.put("id", materialMap.get("material_id"));
        //副表数据
        //子表数据
            realList.add(materialMap);
        }
        //数据转换
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        realList = generaterSwapUtil.swapDataList(realList, MaterialConstant.getFormData(), MaterialConstant.getColumnData(), materialPagination.getModuleId(),isPc?false:false);

        //返回对象
        PageListVO vo = new PageListVO();
        vo.setList(realList);
        PaginationVO page = JsonUtil.getJsonToBean(materialPagination, PaginationVO.class);
        vo.setPagination(page);
        return ActionResult.success(vo);
    }
    /**
    * 创建
    *
    * @param materialForm
    * @return
    */
    @PostMapping()
    @Operation(summary = "创建")
    public ActionResult create(@RequestBody @Valid MaterialForm materialForm) {
        String b = materialService.checkForm(materialForm,0);
        if (StringUtil.isNotEmpty(b)){
            return ActionResult.fail(b );
        }
        try{
            materialService.saveOrUpdate(materialForm, null ,true);
        }catch(Exception e){
            return ActionResult.fail(MsgCode.FA028.get());
        }
        return ActionResult.success(MsgCode.SU001.get());
    }
    /**
    * 导出Excel
    *
    * @return
    */
    @Operation(summary = "导出Excel")
    @PostMapping("/Actions/Export")
    public ActionResult Export(@RequestBody MaterialPagination materialPagination) throws IOException {
        if (StringUtil.isEmpty(materialPagination.getSelectKey())){
            return ActionResult.fail(MsgCode.IMP011.get());
        }
        List<MaterialEntity> list= materialService.getList(materialPagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (MaterialEntity entity : list) {
        Map<String, Object> materialMap=JsonUtil.entityToMap(entity);
        materialMap.put("id", materialMap.get("material_id"));
        //副表数据
        //子表数据
            realList.add(materialMap);
        }
        //数据转换
        realList = generaterSwapUtil.swapDataList(realList, MaterialConstant.getFormData(), MaterialConstant.getColumnData(), materialPagination.getModuleId(),false);
        String[]keys=!StringUtil.isEmpty(materialPagination.getSelectKey())?materialPagination.getSelectKey():new String[0];
        UserInfo userInfo=userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(materialPagination.getMenuId());

            DownloadVO vo=this.creatModelExcel(configValueUtil.getTemporaryFilePath(),realList,keys,userInfo,menuFullName);
        return ActionResult.success(vo);
    }

    /**
    * 导出表格方法
    */
    public DownloadVO creatModelExcel(String path,List<Map<String, Object>>list,String[]keys,UserInfo userInfo,String menuFullName){
        DownloadVO vo=DownloadVO.builder().build();
        List<ExcelExportEntity> entitys=new ArrayList<>();
        if(keys.length>0){
            for(String key:keys){
                switch(key){
                    case "material_code" :
                    entitys.add(new ExcelExportEntity("物料编码" ,"material_code"));
                    break;
                    case "material_name" :
                    entitys.add(new ExcelExportEntity("物料名称" ,"material_name"));
                    break;
                    case "material_category" :
                    entitys.add(new ExcelExportEntity("物料分类" ,"material_category"));
                    break;
                    case "material_model" :
                    entitys.add(new ExcelExportEntity("规格型号" ,"material_model"));
                    break;
                    case "unit_name" :
                    entitys.add(new ExcelExportEntity("单位名称" ,"unit_name"));
                    break;
                    case "brand" :
                    entitys.add(new ExcelExportEntity("品牌" ,"brand"));
                    break;
                    case "tax_rate" :
                    entitys.add(new ExcelExportEntity("税率" ,"tax_rate"));
                    break;
                    case "tax_code" :
                    entitys.add(new ExcelExportEntity("税收分类" ,"tax_code"));
                    break;
                    case "texture" :
                    entitys.add(new ExcelExportEntity("材质/纹理" ,"texture"));
                    break;
                    case "quality_standard" :
                    entitys.add(new ExcelExportEntity("质量标准" ,"quality_standard"));
                    break;
                    case "technical_standard" :
                    entitys.add(new ExcelExportEntity("技术标准" ,"technical_standard"));
                    break;
                    case "acceptance_criteria" :
                    entitys.add(new ExcelExportEntity("验收标准" ,"acceptance_criteria"));
                    break;
                    case "delivery_requirements" :
                    entitys.add(new ExcelExportEntity("交付要求" ,"delivery_requirements"));
                    break;
                    case "storage_conditions" :
                    entitys.add(new ExcelExportEntity("储存条件" ,"storage_conditions"));
                    break;
                    default:
                    break;
                }
            }
        }

        ExportParams exportParams = new ExportParams(null, "表单信息");
        exportParams.setType(ExcelType.XSSF);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //去除空数据
                List<Map<String, Object>> dataList = new ArrayList<>();
                for (Map<String, Object> map : list) {
                    int i = 0;
                    for (String key : keys) {
                        //子表
                        if (key.toLowerCase().startsWith("tablefield")) {
                            String tableField = key.substring(0, key.indexOf("-" ));
                            String field = key.substring(key.indexOf("-" ) + 1);
                            Object o = map.get(tableField);
                            if (o != null) {
                                List<Map<String, Object>> childList = (List<Map<String, Object>>) o;
                                for (Map<String, Object> childMap : childList) {
                                    if (childMap.get(field) != null) {
                                        i++;
                                    }
                                }
                            }
                        } else {
                            Object o = map.get(key);
                            if (o != null) {
                                i++;
                            }
                        }
                    }
                    if (i > 0) {
                        dataList.add(map);
                    }
                }
                List<ExcelExportEntity> mergerEntitys = new ArrayList<>(entitys);
                List<Map<String, Object>> mergerList=new ArrayList<>(dataList);
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(MaterialConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                    dataList =  VisualUtils.complexHeaderDataHandel(dataList, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                }

                exportParams.setStyle(ExcelExportStyler.class);
                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, dataList);
                VisualUtils.mergerVertical(workbook, mergerEntitys, mergerList);
                ExcelModel excelModel = generaterSwapUtil.getExcelParams(MaterialConstant.getFormData(),Arrays.asList(keys));
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }
            String fileName = menuFullName  +"_"+ DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            log.error("信息导出Excel错误:{}", e.getMessage());
            e.printStackTrace();
        }
        return vo;
    }
    @Operation(summary = "上传文件")
    @PostMapping("/Uploader")
    public ActionResult<Object> Uploader() {
        List<MultipartFile> list = UpUtil.getFileAll();
        MultipartFile file = list.get(0);
        if (file.getOriginalFilename().endsWith(".xlsx") || file.getOriginalFilename().endsWith(".xls")) {
            String filePath = XSSEscape.escape(configValueUtil.getTemporaryFilePath());
            String fileName = XSSEscape.escape(RandomUtil.uuId() + "." + UpUtil.getFileType(file));
            //上传文件
            FileInfo fileInfo = FileUploadUtils.uploadFile(file, filePath, fileName);
            DownloadVO vo = DownloadVO.builder().build();
            vo.setName(fileInfo.getFilename());
            return ActionResult.success(vo);
        } else {
            return ActionResult.fail(MsgCode.FA017.get());
        }
    }

    /**
    * 模板下载
    *
    * @return
    */
    @Operation(summary = "模板下载")
    @GetMapping("/TemplateDownload")
    public ActionResult<DownloadVO>  TemplateDownload(@RequestParam("menuId") String menuId){
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(menuId);
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
                entitys.add(new ExcelExportEntity("物料名称(material_name)" ,"material_name"));
                selectKeys.add("material_name");
                entitys.add(new ExcelExportEntity("物料分类(material_category)" ,"material_category"));
                selectKeys.add("material_category");
                entitys.add(new ExcelExportEntity("规格型号(material_model)" ,"material_model"));
                selectKeys.add("material_model");
                entitys.add(new ExcelExportEntity("单位名称(unit_name)" ,"unit_name"));
                selectKeys.add("unit_name");
                entitys.add(new ExcelExportEntity("品牌(brand)" ,"brand"));
                selectKeys.add("brand");
                entitys.add(new ExcelExportEntity("税率(tax_rate)" ,"tax_rate"));
                selectKeys.add("tax_rate");
                entitys.add(new ExcelExportEntity("税收分类(tax_code)" ,"tax_code"));
                selectKeys.add("tax_code");
                entitys.add(new ExcelExportEntity("材质/纹理(texture)" ,"texture"));
                selectKeys.add("texture");
                entitys.add(new ExcelExportEntity("质量标准(quality_standard)" ,"quality_standard"));
                selectKeys.add("quality_standard");
                entitys.add(new ExcelExportEntity("技术标准(technical_standard)" ,"technical_standard"));
                selectKeys.add("technical_standard");
                entitys.add(new ExcelExportEntity("验收标准(acceptance_criteria)" ,"acceptance_criteria"));
                selectKeys.add("acceptance_criteria");
                entitys.add(new ExcelExportEntity("交付要求(delivery_requirements)" ,"delivery_requirements"));
                selectKeys.add("delivery_requirements");
                entitys.add(new ExcelExportEntity("储存条件(storage_conditions)" ,"storage_conditions"));
                selectKeys.add("storage_conditions");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(MaterialConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.add(excelModel.getDataMap());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        try{
        @Cleanup Workbook workbook = new HSSFWorkbook();
        if (entitys.size()>0){
            if (list.size()==0){
                list.add(new HashMap<>());
            }
            //复杂表头-表头和数据处理
            ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(MaterialConstant.getColumnData(), ColumnDataModel.class);
            List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
            if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
            }
            workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
            ExcelHelper helper = new ExcelHelper();
            helper.init(workbook, exportParams, entitys, excelModel);
            helper.doPreHandle();
            helper.doPostHandle();
        }
        String fileName = menuFullName + "导入模板.xls";
        MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
        vo.setName(fileInfo.getFilename());
        vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
        log.error("模板信息导出Excel错误:{}", e.getMessage());
        e.printStackTrace();
        }
        return ActionResult.success(vo);
    }

    /**
    * 导入预览
    *
    * @return
    */
    @Operation(summary = "导入预览" )
    @GetMapping("/ImportPreview")
    public ActionResult<Map<String, Object>> ImportPreview(String fileName) throws Exception {
        Map<String, Object> headAndDataMap = new HashMap<>(2);
            String filePath = FileUploadUtils.getLocalBasePath() + configValueUtil.getTemporaryFilePath();
            FileUploadUtils.downLocal(configValueUtil.getTemporaryFilePath(), filePath, fileName);
        File temporary = new File(XSSEscape.escapePath(filePath + fileName));
            int headerRowIndex = 1;
        ImportParams params = new ImportParams();
        params.setTitleRows(0);
        params.setHeadRows(headerRowIndex);
        params.setNeedVerify(true);
        try {
            InputStream inputStream = ExcelUtil.solveOrginTitle(temporary, headerRowIndex);
            List<Map> excelDataList = ExcelUtil.importExcelByInputStream(inputStream, 0, headerRowIndex, Map.class);
            //数据超过1000条
            if(excelDataList != null && excelDataList.size() > 1000) {
                return ActionResult.fail(MsgCode.ETD117.get());
            }

            ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(MaterialConstant.getColumnData(), ColumnDataModel.class);
            UploaderTemplateModel uploaderTemplateModel = JsonUtil.getJsonToBean(columnDataModel.getUploaderTemplateJson(), UploaderTemplateModel.class);
            List<String> selectKey = uploaderTemplateModel.getSelectKey();
            //子表合并
            List<Map<String, Object>> results = FormExecelUtils.dataMergeChildTable(excelDataList,selectKey);
            // 导入字段
            List<ExcelImFieldModel> columns = new ArrayList<>();
            columns.add(new ExcelImFieldModel("material_name","物料名称","input"));
            columns.add(new ExcelImFieldModel("material_category","物料分类","cascader"));
            columns.add(new ExcelImFieldModel("material_model","规格型号","input"));
            columns.add(new ExcelImFieldModel("unit_name","单位名称","input"));
            columns.add(new ExcelImFieldModel("brand","品牌","input"));
            columns.add(new ExcelImFieldModel("tax_rate","税率","select"));
            columns.add(new ExcelImFieldModel("tax_code","税收分类","cascader"));
            columns.add(new ExcelImFieldModel("texture","材质/纹理","input"));
            columns.add(new ExcelImFieldModel("quality_standard","质量标准","input"));
            columns.add(new ExcelImFieldModel("technical_standard","技术标准","textarea"));
            columns.add(new ExcelImFieldModel("acceptance_criteria","验收标准","textarea"));
            columns.add(new ExcelImFieldModel("delivery_requirements","交付要求","textarea"));
            columns.add(new ExcelImFieldModel("storage_conditions","储存条件","textarea"));
            headAndDataMap.put("dataRow" , results);
            headAndDataMap.put("headerRow" , JsonUtil.getJsonToList(JsonUtil.getListToJsonArray(columns)));
            } catch (Exception e){
            e.printStackTrace();
            return ActionResult.fail(MsgCode.VS407.get());
        }
        return ActionResult.success(headAndDataMap);
    }

    /**
    * 导入数据
    *
    * @return
    */
    @Operation(summary = "导入数据" )
    @PostMapping("/ImportData")
    public ActionResult<ExcelImportModel> ImportData(@RequestBody VisualImportModel visualImportModel) throws Exception {
        List<Map<String, Object>> listData = visualImportModel.getList();
        ImportFormCheckUniqueModel uniqueModel = new ImportFormCheckUniqueModel();
        uniqueModel.setDbLinkId(MaterialConstant.DBLINKID);
        uniqueModel.setUpdate(Objects.equals("2", "2"));

        Map<String,String> tablefieldkey = new HashMap<>();
        for(String key:MaterialConstant.TABLEFIELDKEY.keySet()){
        tablefieldkey.put(key,MaterialConstant.TABLERENAMES.get(MaterialConstant.TABLEFIELDKEY.get(key)));
        }
        ExcelImportModel excelImportModel = generaterSwapUtil.importData(MaterialConstant.getFormData(),listData,uniqueModel, tablefieldkey,MaterialConstant.getTableList());
        List<ImportDataModel> importDataModel = uniqueModel.getImportDataModel();
        for (ImportDataModel model : importDataModel) {
            String id = model.getId();
            Map<String, Object> result = model.getResultData();
            if(StringUtil.isNotEmpty(id)){
                update(id, JsonUtil.getJsonToBean(result,MaterialForm.class), true);
            }else {
                create( JsonUtil.getJsonToBean(result,MaterialForm.class));
            }
        }
        return ActionResult.success(excelImportModel);
    }

    /**
    * 导出异常报告
    *
    * @return
    */
    @Operation(summary = "导出异常报告")
    @PostMapping("/ImportExceptionData")
    public ActionResult<DownloadVO> ImportExceptionData(@RequestBody VisualImportModel visualImportModel) {
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(visualImportModel.getMenuId());
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        entitys.add(new ExcelExportEntity("异常原因", "errorsInfo",30));
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
                entitys.add(new ExcelExportEntity("物料名称(material_name)" ,"material_name"));
                selectKeys.add("material_name");
                entitys.add(new ExcelExportEntity("物料分类(material_category)" ,"material_category"));
                selectKeys.add("material_category");
                entitys.add(new ExcelExportEntity("规格型号(material_model)" ,"material_model"));
                selectKeys.add("material_model");
                entitys.add(new ExcelExportEntity("单位名称(unit_name)" ,"unit_name"));
                selectKeys.add("unit_name");
                entitys.add(new ExcelExportEntity("品牌(brand)" ,"brand"));
                selectKeys.add("brand");
                entitys.add(new ExcelExportEntity("税率(tax_rate)" ,"tax_rate"));
                selectKeys.add("tax_rate");
                entitys.add(new ExcelExportEntity("税收分类(tax_code)" ,"tax_code"));
                selectKeys.add("tax_code");
                entitys.add(new ExcelExportEntity("材质/纹理(texture)" ,"texture"));
                selectKeys.add("texture");
                entitys.add(new ExcelExportEntity("质量标准(quality_standard)" ,"quality_standard"));
                selectKeys.add("quality_standard");
                entitys.add(new ExcelExportEntity("技术标准(technical_standard)" ,"technical_standard"));
                selectKeys.add("technical_standard");
                entitys.add(new ExcelExportEntity("验收标准(acceptance_criteria)" ,"acceptance_criteria"));
                selectKeys.add("acceptance_criteria");
                entitys.add(new ExcelExportEntity("交付要求(delivery_requirements)" ,"delivery_requirements"));
                selectKeys.add("delivery_requirements");
                entitys.add(new ExcelExportEntity("储存条件(storage_conditions)" ,"storage_conditions"));
                selectKeys.add("storage_conditions");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(MaterialConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.addAll(visualImportModel.getList());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        exportParams.setFreezeCol(1);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(MaterialConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                    list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
                }

                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }

            String fileName = menuFullName + "错误报告_" + DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ActionResult.success(vo);
    }
    /**
    * 删除
    * @param id
    * @return
    */
    @Operation(summary = "删除")
    @DeleteMapping("/{id}")
    @Transactional
    public ActionResult delete(@PathVariable("id") String id,@RequestParam(name = "forceDel",defaultValue = "false") boolean forceDel) throws Exception{
        MaterialEntity entity= materialService.getInfo(id);
        if(entity!=null){
            //假删除
            entity.setDeleteMark(1);
            entity.setDeleteUserId(userProvider.get().getUserId());
            entity.setDeleteTime(new Date());
            materialService.setIgnoreLogicDelete().updateById(entity);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
    * 批量删除
    * @param obj
    * @return
    */
    @DeleteMapping("/batchRemove")
    @Transactional
    @Operation(summary = "批量删除")
    public ActionResult batchRemove(@RequestBody Object obj){
    Map<String, Object> objectMap = JsonUtil.entityToMap(obj);
    List<String> idList = JsonUtil.getJsonToList(objectMap.get("ids"), String.class);
    String errInfo = "";
    List<String> successList = new ArrayList<>();
        for (String allId : idList){
            try {
                this.delete(allId,false);
                successList.add(allId);
            } catch (Exception e) {
                errInfo = e.getMessage();
            }
        }
        if (successList.size() == 0 && StringUtil.isNotEmpty(errInfo)){
            return ActionResult.fail(errInfo);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
    * 编辑
    * @param id
    * @param materialForm
    * @return
    */
    @PutMapping("/{id}")
    @Operation(summary = "更新")
    public ActionResult update(@PathVariable("id") String id,@RequestBody @Valid MaterialForm materialForm,
                                @RequestParam(value = "isImport", required = false) boolean isImport){
        MaterialEntity entity= materialService.getInfo(id);
        if(entity!=null){
            materialForm.setMaterialId(String.valueOf(entity.getMaterialId()));

            if (!isImport) {
                String b =  materialService.checkForm(materialForm,1);
                if (StringUtil.isNotEmpty(b)){
                    return ActionResult.fail(b );
                }
            }

            try{
                materialService.saveOrUpdate(materialForm,id,false);
            }catch (DataException e1){
                return ActionResult.fail(e1.getMessage());
            }catch(Exception e){
                return ActionResult.fail(MsgCode.FA029.get());
            }
            return ActionResult.success(MsgCode.SU004.get());
        }else{
            return ActionResult.fail(MsgCode.FA002.get());
        }
    }
    /**
    * 表单信息(详情页)
    * 详情页面使用-转换数据
    * @param id
    * @return
    */
    @Operation(summary = "表单信息(详情页)")
    @GetMapping("/detail/{id}")
    public ActionResult detailInfo(@PathVariable("id") String id){
        MaterialEntity entity= materialService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> materialMap=JsonUtil.entityToMap(entity);
        materialMap.put("id", materialMap.get("material_id"));
        //副表数据
        //子表数据
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        materialMap = generaterSwapUtil.swapDataDetail(materialMap,MaterialConstant.getFormData(),"817350987260887813",isPc?false:false);
        //子表数据
        return ActionResult.success(materialMap);
    }
    /**
    * 获取详情(编辑页)
    * 编辑页面使用-不转换数据
    * @param id
    * @return
    */
    @Operation(summary = "信息")
    @GetMapping("/{id}")
    public ActionResult info(@PathVariable("id") String id){
        MaterialEntity entity= materialService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> materialMap=JsonUtil.entityToMap(entity);
        materialMap.put("id", materialMap.get("material_id"));
        //副表数据
        //子表数据
        materialMap = generaterSwapUtil.swapDataForm(materialMap,MaterialConstant.getFormData(),MaterialConstant.TABLEFIELDKEY,MaterialConstant.TABLERENAMES);
        return ActionResult.success(materialMap);
    }

}
